# -*- coding: utf-8 -*-
from __future__ import print_function, division

import sip
sip.setapi('QString', 2)
sip.setapi('QVariant', 2)

from PyQt4.QtCore import pyqtRemoveInputHook
from PyQt4.QtGui import QApplication
import sys
import os
import argparse
import signal

# Local imports
from qcobj.cfggui import CfgGui

signal.signal(signal.SIGINT, signal.SIG_DFL)
pyqtRemoveInputHook()

#==============================================================================
if __name__ == '__main__':

    parser = argparse.ArgumentParser(
        description="\nEdit QConfigobj configuration files in a GUI.",
        add_help=True,
        formatter_class=argparse.ArgumentDefaultsHelpFormatter,
        prog=os.path.basename(sys.argv[0]))

    parser.add_argument('-c', '--configspec',
        help=("ConfigSpec file. Configuration files will be validated "
            "against this file ")
        )
    parser.add_argument('cfg', default=None, nargs='*',
        help=("Configuration file. Configuration parameters will be loaded "
            "from this file ")
        )
    parser.add_argument('-s', '--strict', default=True,
        action='store_false',
        help=("Validate cfg against configspec ")
        )
    parser.add_argument('-n', '--noextra', default=True,
        action='store_false',
        help=("Forbid extra keywords / sections NOT in configspec files ")
        )
    options = parser.parse_args(sys.argv[1:])

    app = QApplication(sys.argv)
    cfgGui = CfgGui(options)
    cfgGui.setGeometry(0, 0, 1000, 800)
    cfgGui.show()
    sys.exit(app.exec_())

